/**
Author: 
    Calin Bira (calin.bira@upb.ro)
    Costin Vasile (costin.vasile1003@upb.ro)

Main file for eHealth project

- Temp: fir (jack audio)
- SPO2: baterie si BLE
- BP: incarcare din acumulator
- display panglica
- Spirometru: miniUSB data

TODO:
e-Health:

// Management interface is at:
// http://saveaal.eu:4200/admincentre

*/
#define SLEEP_SECONDS 20
#define STARTUP_DISPLAY_ON_SECONDS 60

#include "issDebug.hpp"
#include "issTemperatureSense.hpp"
#include "issPulseOximeter.hpp"
#include "issBloodPressure.hpp"
#include "issBLE.hpp"
#include "issWebClient.hpp"
#include "issDisplay.hpp"
#include <ArduinoLowPower.h>

issTemperatureSense ts(A6);
issBLE ble;
issPulseOximeter spo2(&ble);
issBloodPressureMeter bp(&ble);
issDisplay disp;
issDisplay *pdisp = &disp;

char ssid[] = "issEhealth"; char pass[] = "1q2w3e4r";
char ehealth_apiKey[] = "wnBQ%9uGj%sHtkHb#zjZuPbWPbVuR!6hsQwj$_3XAyPbQ3D#KYjaAhXMGPJUQYz-";

int ehealth_port = 85;
char path[] = "http://86.122.59.60:85/api/save-sensors-data";
char server[] = "86.122.59.60";

issWebClient client(server, ssid, pass);

long startupMilliseconds;
void setup() {
  Serial.begin(9600);
  Serial1.begin(9600);

  disp.init();
  disp.drawString("ISS app started!");

  disp.fadeBacklight(BACKLIGHT_ON);
  Serial.println("BACKLIGHT_ON");
  startupMilliseconds = millis();
}

void loop() {
  const String equipement_idstr = "1234";
  const int user_id = 2;

  String body = "{\"EQUID\":\"" + equipement_idstr + "\",\"USID\":" + String(user_id);
  int initialDataSize = body.length() + 1;

  ble.init();

  Serial.println("ts.loop+ in");
    //float lastTemp = ts.getC(); 
    //delay(1000); 
    //while (lastTemp < ts.getC()) {
    //  lastTemp = ts.getC();
    //  delay(1000);      
    //}
    //Serial.println("Peak temp detected at " + String(lastTemp) + " deg.C");
  ts.loop();
  Serial.println("ts.loop+ out");
  if (ts.isAvailable()) body += ts.consumeToJSONstring();
  
  
  Serial.println("spo2.loop in");
  long ms = millis();
  while ((spo2.loop() == false) && (millis() - ms < 2000))
  ;  
  Serial.println("spo2.loop out");
  if (spo2.isAvailable()) {
    body += spo2.consumeToJSONstring();
  }

  bp.loop();
  if (bp.isAvailable()) {
    body += bp.consumeToJSONstring();
  }
  
  body += "}";

  spo2.reset();
  ble.end();

  Serial.println(body);
  if (body.length() > initialDataSize) {
    disp.fadeBacklight(BACKLIGHT_ON);
    Serial.println("BACKLIGHT_ON");
    Serial.println("in do_POST");
    int retry = 5;
    while (false == client.do_POST(body.c_str(), body.length(), path, ehealth_apiKey, ehealth_port))
    {
      if (retry-- == 0) break;
    };
    
    Serial.println("out of do_POST");
  }

  if (millis() - startupMilliseconds > STARTUP_DISPLAY_ON_SECONDS * 1000) {
    disp.fadeBacklight(BACKLIGHT_OFF);
    Serial.println("BACKLIGHT_OFF here");
    delay(5000);
  }
  //Serial.println("entering sleep...");
  //LowPower.sleep(SLEEP_SECONDS * 1000);  
  //Serial.println("out of sleep!");
}
