#pragma once
#include "issModule.hpp"

class issTemperatureSense : public issModule {
    private:
      int lastValidValue = 0;
      const int startC = 23;
                    //23C,  24,  25,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,  45, 46, 47
      int values[25] ={303, 306, 310, 316, 322, 332, 336, 339, 365, 372, 383, 387, 395, 402, 421, 432, 447, 457, 468, 479, 489, 497, 505, 512, 527};
      int mAnalogPin;

    public:
      issTemperatureSense(int pin) {
      mAnalogPin = pin;
    }

    float getC() {
      int val = 0;
      for (int loop = 0; loop < 16; loop++)
        val += analogRead(A6);
      val = val >> 4;
      
      unsigned i = 0;
      for (i = 0; i < sizeof(values)/sizeof(values[0]); i++)
        if (values[i] > val) break;

      if ((i > 0) && (i < 25)) {
          float valuesPerDegree = values[i] - values[i-1];
          return startC + i-1 + (val - values[i-1])/valuesPerDegree;
      }
      else return startC + i - 1;
    }

    bool loop() {
      // "TEMP": [T_SUTIMI_DE_GRADE_CELSIUS], // int 0-999 ( echivalent 0 - 99.9 grade Celsius)

      #ifndef USE_DUMMY_DATA
        float lastValue = getC();
        if (lastValue < 34) return false;
        //else:
        lastValidValue = lastValue*10;
      #else
        lastValidValue = ((lastValidValue + 1) % 100) + 300;
      #endif
    produce();
    return true;
   }

    String consumeToJSONstring() {
      if (isAvailable()) {consume(); return ",\"TEMP\":" + String(lastValidValue);}
      else return "";
    }
};
