#pragma once

#include "issSmartLED.hpp"

class issSmartRGB {
  private:
    int mDelayms;
    issLED *pLEDs[3];

  public:
    issSmartRGB(int R, int G, int B, int delayms, bool blockingMode = false) {
      mDelayms = delayms;

      if (blockingMode == false) {
        pLEDs[0] = new issSmartLED(R, delayms, delayms);
        pLEDs[1] = new issSmartLED(G, delayms, delayms);
        pLEDs[2] = new issSmartLED(B, delayms, delayms);
      }
      else {
        pLEDs[0] = new issLED(R, delayms, delayms);
        pLEDs[1] = new issLED(G, delayms, delayms);
        pLEDs[2] = new issLED(B, delayms, delayms);
      }
    }
  
    ~issSmartRGB() {
      delete(pLEDs[0]);
      delete(pLEDs[1]);
      delete(pLEDs[2]);
    }
    
    void blinkRed(int msOn, int msOff = 0, bool restart = false)   { pLEDs[0]->blink(msOn, msOff, restart); }
    void blinkGreen(int msOn, int msOff = 0, bool restart = false) { pLEDs[1]->blink(msOn, msOff, restart); }
    void blinkBlue(int msOn, int msOff = 0, bool restart = false)  { pLEDs[2]->blink(msOn, msOff, restart); }
    
    void blinkWhite(int msOn, int msOff = 0, bool restart = false)  {
      blinkRed(msOn, msOff, restart);
      blinkGreen(msOn, msOff, restart);
      blinkBlue(msOn, msOff, restart);
    }

    void switchAllOff() {
      pLEDs[0]->switchOff();
      pLEDs[1]->switchOff();
      pLEDs[2]->switchOff();
    }

    void switchRedOn() {
      pLEDs[0]->switchOn();
    }

    void switchGreenOn() {
      pLEDs[1]->switchOn();
    }

    void switchBlueOn() {
      pLEDs[2]->switchOn();
    }

    void showAllWork() {
      switchAllOff();
      switchRedOn(); delay(800); switchAllOff();
      switchGreenOn(); delay(800); switchAllOff();
      switchBlueOn(); delay(800); switchAllOff();  
    }
};
