class issSpeaker {

  #define HIGH_FREQ_HZ 2000
  #define LOW_FREQ_HZ 220
  #define WRONG_FREQ_HZ 400
  #define WRONG_DUR_MS 150

  int mPin;
  volatile bool isSendingSound;
  volatile int lastFrequencyHz;
  volatile int lastDuration;
  volatile int lastTimestamp;
  
  public:
    issSpeaker(int p) {
      mPin = p;
      pinMode(mPin, OUTPUT);
      isSendingSound = false;
      lastFrequencyHz = 0;
      lastTimestamp = millis();
      lastDuration = 0;
  }

  void doCRTstart() {
    dotone(mPin, HIGH_FREQ_HZ, 150);
  }

  void doCRTwrong() {
    dotone(mPin, WRONG_FREQ_HZ, WRONG_DUR_MS);
  }

  void doCRTfinished() {
    dotone(mPin, HIGH_FREQ_HZ, 1500);
  }  

  // do not call this from ISR
  void doSoundDataWasSent() {
    dotone(mPin, LOW_FREQ_HZ, 100);
    delay(200);
    dotone(mPin, LOW_FREQ_HZ, 100);
    delay(200);
  }

  void dotone(int pin, int FreqHz, int ms) {
     if ((lastFrequencyHz != FreqHz) || (lastTimestamp + lastDuration < millis()))  {
          tone(pin, FreqHz, ms);
          lastFrequencyHz = FreqHz;
          lastDuration = ms;
          lastTimestamp = millis();
     }
     //else : do not output same thing
  }
};
