#pragma once

class issRandom {
  public:
    issRandom(int randomPinSource = A0) {
        randomSeed(analogRead(randomPinSource));
    }

    int getRandomNumber(int From, int LessThanValue) {
      return random(From, LessThanValue);
    }
};

template <typename T> class issAvg {
  #define NUM_VALUES 10UL
  T values[NUM_VALUES];
  uint32_t index;
 
  public:
    issAvg() {
      clear();  
    }
    
    void clear() {
      index = 0;
    }

    void pushValue(T value) {
      if (index < NUM_VALUES)
        values[(index++) % NUM_VALUES] = value;      
    }

    T getAvg() {
      if (index == 0) return 0;
      else {
        uint32_t sum = 0;
        for (uint16_t i = 0; i < min(index, NUM_VALUES); i++)
          sum += values[i];      
        return sum / min(index, NUM_VALUES);
      }
    }
};
