#include <SPI.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiSpi.h"

//extend SSD1306Ascii class
class SSD1306AsciiPlus : public SSD1306AsciiSpi {
public:
  void setDisplay(bool TrueOnFalseOff) {
    ssd1306WriteCmd(TrueOnFalseOff ? SSD1306_DISPLAYON : SSD1306_DISPLAYOFF);
  }
};

class issWxDisplay {
  #define ISS_WX_CS_PIN  A5  
  #define ISS_WX_RST_PIN A4
  #define ISS_WX_DC_PIN  A3

  SSD1306AsciiPlus oled;
  String SPACES = "                    ";
  
public:
  void init() {
    // Use next line if no RST_PIN or reset is not required.
    // oled.begin(&Adafruit128x64, CS_PIN, DC_PIN);  
    oled.begin(&Adafruit128x64, ISS_WX_CS_PIN, ISS_WX_DC_PIN, ISS_WX_RST_PIN);
    oled.setFont(Adafruit5x7);  
    oled.clear();
  }

  void print(String str, short row = -1) {
    if (row > -1) oled.setRow(row);
    oled.print(str + SPACES);
  }

  void println (String str, short row = -1) {
    if (row > -1) oled.setRow(row);
    oled.println(str + SPACES);
  }

  void turn(bool OnOff) {
    oled.setDisplay(OnOff);
  }
//------------------------------------------------------------------------------
void loop() {}  
};
