
#include "issStatus.hpp"

class issCRT {
  int mCRT_LED_R;
  int mCRT_LED_G;
  int mCRT_LED_B;
  int mCRT_BUTTON_LEFT;
  int mCRT_BUTTON_RIGHT;

  char ledPins[3] = {CRT_LED_R, CRT_LED_G, CRT_LED_B};
  issStatus *mpStatus;

  public:
    issCRT(int crtLedR, int crtLedG, int crtLedB, int crtButtonLeft, int crtButtonRight, issStatus *pStatus) {
      mCRT_LED_R = crtLedR;
      mCRT_LED_G = crtLedG;
      mCRT_LED_B = crtLedB;

      mCRT_BUTTON_LEFT = crtButtonLeft;
      mCRT_BUTTON_RIGHT = crtButtonRight;

      mpStatus = pStatus;
   }

    bool shouldStart() {
      return false;
    }
  
    void setup() {
       pinMode(mCRT_LED_R, OUTPUT);
       digitalWrite(mCRT_LED_R, HIGH);
       delay(1000);
       digitalWrite(mCRT_LED_R, LOW);
        
       pinMode(mCRT_LED_G, OUTPUT);
       digitalWrite(mCRT_LED_G, HIGH);
       delay(1000);
       digitalWrite(mCRT_LED_G, LOW);
       
       pinMode(mCRT_LED_B, OUTPUT);
       digitalWrite(mCRT_LED_B, HIGH);
       delay(1000);
       digitalWrite(mCRT_LED_B, LOW);
             
       pinMode(mCRT_BUTTON_LEFT, INPUT_PULLUP);
       pinMode(mCRT_BUTTON_RIGHT, INPUT_PULLUP);  
    }

    void runOnce() {
      static long ExperimentTime = millis();
      long SOA_time = millis();
      
      int led = random(0,3);
      digitalWrite(ledPins[led], HIGH);
      long start = millis(); // measurement start
    
      delay(200);
      digitalWrite(ledPins[led], LOW);
    
      bool correct = true; 
      if (ledPins[led] == mCRT_LED_B) // target 
        while (digitalRead(mCRT_BUTTON_RIGHT) != LOW) {
          if (digitalRead(mCRT_BUTTON_LEFT)==LOW) correct = false;
        }
      else
        while (digitalRead(mCRT_BUTTON_LEFT) != LOW) {
          if (digitalRead(mCRT_BUTTON_RIGHT)==LOW) correct = false;
        }
      long stop = millis(); 
    
      if (ledPins[led] == mCRT_LED_R) Serial.println(String(correct) + " R " + String(stop-start));
      else if (ledPins[led] == mCRT_LED_G) Serial.println(String(correct) + " G " + String(stop-start));
      else if (ledPins[led] == mCRT_LED_B) Serial.println(String(correct) + " B " + String(stop-start));  
      
      while (millis() - SOA_time < 2500) {
        //if (digitalRead(BUTTON_LEFT) == LOW) Serial.println("LEFT");
        //if (digitalRead(BUTTON_RIGHT) == LOW) Serial.println("RIGHT");
      }
      ;//wait for SOA
    
      if (millis() - ExperimentTime > 600*1000UL) // 5 minutes
        while (1); 
    }
};
