#include <SPI.h>
#include <WiFiNINA.h>

class issWebServer {
  
  WiFiServer* pServer;
  int mWifiStatus = WL_IDLE_STATUS;
  issStatus *mpStatus;

  public:
  issWebServer(issStatus *pStatus, issCredentials *pCredentials) {
    mpStatus = pStatus;
    pServer = new WiFiServer(80);
    pCredentials->load();
    if (pCredentials->
  }

  void printWiFiStatus() {
    // print the SSID of the network you're attached to:
    Serial.print("SSID: ");
    Serial.println(WiFi.SSID());
  
    // print your WiFi shield's IP address:
    IPAddress ip = WiFi.localIP();
    Serial.print("IP Address: ");
    Serial.println(ip);
  
    // print where to go in a browser:
    Serial.print("To see this page in action, open a browser to http://");
    Serial.println(ip);
  }

  void setupAP(char *ssid, char *pwd) {  
    WiFi.config(IPAddress(192, 168, 4, 1));
    mWifiStatus = WiFi.beginAP(ssid, pwd);
    if (mWifiStatus != WL_AP_LISTENING) {
      Serial.println("Creating access point failed");
      // don't continue
      mpStatus->set(Wifi_CreateAP_Failed);
      return;
    }
  
    // wait 10 seconds for connection:
    delay(10000);
  
    // start the web server on port 80
    pServer->begin();
  
    // you're connected now, so print out the status
    printWiFiStatus();
  }

  void setup(char* ssid, char* pwd) {
    mWifiStatus = WL_IDLE_STATUS;
    while (mWifiStatus != WL_CONNECTED) {
      Serial.print("Connecting to ");
      Serial.println(ssid);
      mWifiStatus = WiFi.begin(ssid, pwd);
      delay(5000);
    }
  
    Serial.print("IP address: ");
    Serial.println(WiFi.localIP());
  
    pServer->begin();
  }

  void run(int seconds) {
    int start = millis();
    while (millis() - start < seconds*1000) {
      WiFiClient client = pServer->available();
      if (client) {
          char prevprev;
        char prev;
        while (client.connected()) {
          if (client.available()) {
            char c = client.read();
            Serial.write(c);
    
            if (prevprev == '\n' && prev == '\r' && c == '\n') {
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              client.println("<!DOCTYPE HTML>");
              client.println("<html>");
              client.println("<body>");
              client.println("<h1>ISS SSID / password </h1>");
              client.println("<form action=\"/wifi.php\" method=\"get\" target=\"_blank\">");
              client.println("<label for=\"ssid\">SSID:</label>");
              client.println("<input type=\"text\" id=\"ssid\" name=\"ssid\"><br><br>");
              client.println("<label for=\"pwd\">PWD:</label>");
              client.println("<input type=\"text\" id=\"pwd\" name=\"pwd\"><br><br>");
              client.println("<input type=\"submit\" value=\"Save & Reboot\">");
              client.println("</form>");
              client.println("</body>");
              client.println("</html>");
              break;
            }
    
            prevprev = prev;
            prev = c;
          }
        }
        client.stop();
    }
  }
  }
};
