#pragma once
#include <EEPROM.h>

#define FIELD_SIZE 20
typedef struct {
   char SSID[FIELD_SIZE];
   char Password[FIELD_SIZE];
   char DataCRC8;
} Credentials_t;
  
class issWifiCredentials {
  Credentials_t mCredentials;
  
public:
  void save()
  {
    mCredentials.DataCRC8 = getCRC();
    EEPROM.put(0, mCredentials);
  }

  void load() {
    EEPROM.get(0, mCredentials);
  }

  char getCRC() {
    char crc8 = 0;
    for (int i = 0; i < FIELD_SIZE; i++) crc8 += mCredentials.SSID[i];
    for (int i = 0; i < FIELD_SIZE; i++) crc8 += mCredentials.Password[i];
    return crc8;
  }
  
  bool areValid() {
    return mCredentials.DataCRC8 == getCRC();
  }

  char* getSSID() {
    return mCredentials.SSID;
  }

  char* getPassword() {
    return mCredentials.Password;
  }
};
