#define CRT_BUTTON_RIGHT 13
#define CRT_BUTTON_LEFT  12
#define CRT_LED_R 8
#define CRT_LED_G 10
#define CRT_LED_B 9

#include "issCRT.hpp"
#include "issWebServer.hpp"
#include "issStatus.hpp"
#include "issWifiCredentials.hpp"

issStatus state;
issCRT crt(CRT_LED_R, CRT_LED_G, CRT_LED_B, CRT_BUTTON_LEFT, CRT_BUTTON_RIGHT, &state);
issWebServer webserver(&state);
issWifiCredentials credentials;

void setup() {
  // put your setup code here, to run once:
   pinMode(LED_BUILTIN, OUTPUT);
   Serial.begin(115200);

   credentials.load();
   
   webserver.run(60);
}

void loop() {
   state.print();
   if (crt.shouldStart()) crt.runOnce();
}
