/**
 * ISS Copyright 2019-2020
 * @author Calin Bira (calin.bira@spacescience.ro / calin.bira@upb.ro)
 */
 
#pragma once

#include "issModule.hpp"

class issBattery : public issModule {

  uint8_t lastValidValue; // in percent
  void init(issDisplay *_pDisplay) 
  {
      pDisplay = _pDisplay;
      mInitialized = true;
  }
  
  public:
    void show() {
      if (pDisplay != NULL) {
        if (isAvailable())
          pDisplay->drawString((String("Battery (%) : ") + String(lastValidValue)).c_str()); 
        else 
          pDisplay->drawString((String("Battery (%) : n/a")).c_str());
      }
  }

  void loop() {
    //"BATTERY": [int16], // in procente 0 - 100 

    #ifndef USE_DUMMY_DATA
      return; // no real battery data
    #else
      lastValidValue = ((lastValidValue + 1) % 100);
    #endif
    produce();
    produce();
  }
  
  int getBatterySOC() {
    return lastValidValue;
  }

  String consumeToJSONstring() {
    if (isAvailable()) {consume(); return ",\"BATTERY\":[" + String(lastValidValue) + "]";}
    else return "";
  }

  String consumeToDisplayedString() {
    if (isAvailable()) {consume(); return " BATTERY " + String(lastValidValue);}
    else return " BATTERY " + getEmptyString();
  }
};
