
typedef enum {
   U8_TESTRUN,
   U8_MOVING_AVERAGE,
   U8_MEDIAN,
   U8_EXPAVG,
   U8_ALPHA_BETA,
}Filter_t;

#define MAX_FILTER_DATA_SIZE 1024

uint8_t volatile mData[MAX_FILTER_DATA_SIZE];
uint8_t volatile mFilteredData; //[MAX_FILTER_DATA_SIZE];
    
class issFilterSpeedtests {
   public:

    void init() {
       for (uint16_t i = 0; i < MAX_FILTER_DATA_SIZE; i++) 
          mData[i] = random(0, 255);
    }

    static inline inplacesort(uint8_t* start, uint8_t* stop) {
      uint8_t* man;
      uint8_t val;

      for (;;) {
        uint8_t replaced = 0;
        man = start;
        do {
          if (*man > *(man+1)) {
            val = *man;
            *man = *(man+1);
            *(man+1) = val;
            replaced = 1;
          }       
          man++;
        } while (man < stop);
        if (replaced == 0) break;
      }
    }
    
    bool runSpeedTest(Filter_t filtertype, int windowSize, int dataSize) {
      if (dataSize > MAX_FILTER_DATA_SIZE) return false;
      if (windowSize > dataSize) return false;
      
      switch (filtertype) {
        case U8_MOVING_AVERAGE: {
          uint16_t sum = 0;

          for (uint16_t i = 0; i < dataSize; i++) {
            sum = 0;
            for (uint16_t j = 0; j < windowSize; j++) sum += mData[i + j];
            mFilteredData/*[i]*/ = sum / windowSize;
          }
          /*
          for (uint16_t i = dataSize-windowSize; i < dataSize; i++) {
            sum += mData[i];
          }

          for (uint16_t i = dataSize-windowSize; i < dataSize; i++) {
            sum -= mData[i];
            mFilteredData[i] = sum / (dataSize-i); 
          }

          sum = 0;
          for (uint16_t i = 0; i < windowSize; i++) {
            sum+=mData[i]; 
            mFilteredData[i] = sum / (i+1);          
          }

          
          for (uint16_t i = windowSize; i < dataSize - windowSize; i+=windowSize) {
              sum -= mData[i];
              sum += mData[i+windowSize-1];
              mFilteredData[i] = sum / windowSize;         
          }*/

          break;
        }  

        case U8_MEDIAN: {
          for (uint16_t i = 0; i < dataSize; i++) {
            inplacesort(&mData[i], &mData[i+windowSize]);
            mFilteredData = mData[(i + windowSize) / 2];
          } 
          break;
        }

        case U8_TESTRUN: {
            for (uint16_t i = 0; i < dataSize; i++)
                volatile uint8_t val = i;  
            break;        
        }
      }

      return true;
    }
};
