/**
 * ISS Copyright 2020
 * @author Calin Bira (calin.bira@spacescience.ro / calin.bira@upb.ro)
 * @author Alexandru Mandu (alexandru.mandu@spacescience.ro)
 */

#pragma once

class issSpirometer : issModule {
uint16_t mValue1 = 0;
uint16_t mValue2 = 0;

public:
  void init(issDisplay *_pDisplay) 
  {
      pDisplay = _pDisplay;
      mInitialized = true;
  }

  void loop()
  {
      #ifndef USE_DUMMY_DATA
        MySignals.enableSensorUART(SPIROMETER);
   
        int tryouts = 10;
        while (tryouts-- > 0) {
          if (MySignals.getStatusSpiro() == 0) continue;
          MySignals.getSpirometer();
          if (MySignals.spir_measures > 0) {
            mValue1 = MySignals.spirometerData[0].spir_pef;
            mValue2 = MySignals.spirometerData[0].spir_fev;
            produce();
            produce(); 
            //MySignals.deleteSpiroMeasures();
            break;
          }
          delay(100);
        }
      #else
        // "SPIROMETER" : [ DEBIT, VOLUM ], // DEBIT un numar int 0-999, litri / minut iar VOLUM este un numar int 0-99 litri

        mValue1 = (mValue1 + 1) % 1000;
        mValue2 = (mValue2 + 1) % 100;
        produce();
        produce();
      #endif
  }

  void show() {
    if (pDisplay != NULL)
      if (isAvailable())
          pDisplay->drawString("Spirometer: " + String(mValue1) + "/" + String(mValue2));
      else 
          pDisplay->drawString("Spirometer: n/a");
  }

  String consumeToJSONstring() {
    if (isAvailable()) 
    {
          //"SPIROMETER" : [ DEBIT, VOLUM ], // DEBIT un numar int 0-999, litri / minut iar VOLUM este un numar int 0-99 litri
          consume(); 
          return  ",\"SPIROMETER\":[" + String(mValue1 * 100) + "," + String(mValue2) + "]";
    }
    else return String(""); 
  }

  String consumeToDisplayedString() {
    if (isAvailable()) {consume(); return " SPIROMETER " + String(mValue1) + ", " + String(mValue2) + getEmptyString();}
    else return " SPIROMETER" + getEmptyString();
  }
};
