import serial
import socket
import time

s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.connect(('8.8.8.8', 1))  # connect() for UDP doesn't send packets
local_ip_address = s.getsockname()[0]

def is_slice_in_list(s,l):
    len_s = len(s) #so we don't recompute length of s on every iteration
    return any(s == l[i:len_s+i] for i in range(len(l) - len_s+1))

class SerialWrapper:
    def __init__(self, device):
        self.ser = serial.Serial(device, 115200)

    def sendData(self, data):
        self.ser.write(data.encode())

    def getData(self):
        return self.ser.readline()

def main():
    ser = SerialWrapper('/dev/ttyUSB0')
    cmdstr = "AT+ISSSENDJSON " + local_ip_address + " 8888 /ehealth/getSensorsData {\"EQUID\":\"00112233445566778899AA\",\"USID\":2,\"BATTERY\":[28]}";
    # ("AT+ISSSENDJSON 86.122.59.60 85 /ehealth/getSensorsData {\"EQUID\":\"00112233445566778899AA\",\"USID\":2,\"BATTERY\":[28]}");

    print(cmdstr);
    print("milliseconds: answer");
    while True:
        #misc code here
        ser.sendData(cmdstr);
        while True:
            data = ser.getData();
            databytes = "AT+ISSSENDJSON OK".encode();
            if is_slice_in_list(databytes,data):
                print(round(time.time()*1000),": ", data);
                break;

main()
