
import sys
import serial
import serial.tools.list_ports
import time
from datetime import datetime

def getTimestamp():
    return str(int(round(time.time() * 1000))) + " " + datetime.now().strftime("%d.%m.%Y %H:%M:%S")

print(getTimestamp())
portlist = serial.tools.list_ports.comports()
print([comport.device for comport in portlist])

if len(sys.argv) > 1:
    chosenPort = sys.argv[1:][0]
else:
    if len(portlist) > 0:
        chosenPort = portlist[0][0]
    else:
        print("No port found / nor selected via command line arguments")

print("Running on port " + chosenPort)

crt_tag = "<CRT>"
mr_tag = "<MM>"
serialPort = serial.Serial(port = chosenPort, baudrate=9600,
                           bytesize=8, timeout=2, stopbits=serial.STOPBITS_ONE)

foutcrt = open("logCRT.txt", "w")
foutmr = open("logMR.txt", "w")
while 1:
    # Wait until there is data waiting in the serial buffer
    if serialPort.in_waiting > 0:
        serialString = serialPort.readline().decode('Ascii')
        ms = getTimestamp()
        if crt_tag in serialString:
            strs = (serialString.strip().split(crt_tag, 1)[1])
            print(ms + " " + strs)
            foutcrt.write(ms + " " + strs + "\n")
            foutcrt.flush()

        if mr_tag in serialString:
            strs = (serialString.strip().split(mr_tag, 1)[1])
            print(ms + " " + strs)
            foutmr.write(ms + " " + strs + "\n")
            foutmr.flush()

foutcrt.close()
foutmr.close()

#fout = open("log.txt", "w")
#log_file = open('putty.log', 'r')
#Lines = log_file.readlines()
#for line in Lines:
#    if crt_tag in line:
#        str = (line.strip().split("<CRT>", 1)[1])
#        print(str)
#        fout.write(str + "\n")
#fout.close()






