package gui;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.BevelBorder;

/**
 *
 * @author Radu Hobincu (radu.hobincu@upb.ro)
 * @author Calin Bira (calin.bira@upb.ro)
 */
public final class oldGUI extends javax.swing.JFrame {
    int mResizedWidth;
    int mResizedHeight;

public oldGUI() {
    initComponents();
}

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {


        Image = new javax.swing.JPanel();
        Info = new javax.swing.JPanel();

        jScrollPane1 = new javax.swing.JScrollPane();
        MenuBar = new javax.swing.JMenuBar();

        FileMenu = new javax.swing.JMenu();
        ExitMenuItem = new javax.swing.JMenuItem();
        OptionsMenu = new javax.swing.JMenu();

        HelpMenu = new javax.swing.JMenu();
        HowToMenuItem = new javax.swing.JMenuItem();
        About = new javax.swing.JMenuItem();

        statusLabel1 = new JLabel();
        statusLabel2 = new JLabel();
        progressBar = new JProgressBar(JProgressBar.HORIZONTAL, 0, 100);
        progressBar.setValue(0);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        setTitle("MMCRTsplit v0.1");
        setMinimumSize(new java.awt.Dimension(1536, 800));
        setResizable(false);

        JPanel statusPanel = new JPanel();
        statusPanel.setBorder(new BevelBorder(BevelBorder.LOWERED));
        statusPanel.setPreferredSize(new Dimension(Image.getWidth(), 20));
        //statusPanel.setLayout(new BoxLayout(statusPanel, BoxLayout.X_AXIS));
        statusPanel.setLayout(new BorderLayout());

        progressBar.setMinimumSize(new Dimension(Image.getWidth() / 4, 20));
        statusLabel1.setHorizontalAlignment(SwingConstants.LEFT);
        statusLabel2.setHorizontalAlignment(SwingConstants.RIGHT);

        long allocatedMemory =
                (Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory());
        long presumableFreeMemory = Runtime.getRuntime().maxMemory() - allocatedMemory;

        statusLabel1.setText(" Idle");
        statusLabel2.setText(" Free RAM (MB) : " + presumableFreeMemory / 1024 / 1024);

        statusPanel.add(progressBar, BorderLayout.LINE_START);
        statusPanel.add(statusLabel1, BorderLayout.CENTER);
        statusPanel.add(statusLabel2, BorderLayout.LINE_END);

        Image.add(statusPanel, java.awt.BorderLayout.PAGE_END);

        getContentPane().add(Image, java.awt.BorderLayout.WEST);

        Info.setMaximumSize(new java.awt.Dimension(384, 800));
        Info.setMinimumSize(new java.awt.Dimension(384, 800));
        Info.setPreferredSize(new java.awt.Dimension(384, 800));

        jScrollPane1.setMaximumSize(new java.awt.Dimension(384, 800));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(384, 800));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(384, 800));


        javax.swing.GroupLayout InfoLayout = new javax.swing.GroupLayout(Info);
        Info.setLayout(InfoLayout);
        InfoLayout.setHorizontalGroup(
            InfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 384, Short.MAX_VALUE)
            .addGroup(InfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(InfoLayout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
        InfoLayout.setVerticalGroup(
            InfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1600, Short.MAX_VALUE)
            .addGroup(InfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(InfoLayout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );

        getContentPane().add(Info, java.awt.BorderLayout.EAST);

        FileMenu.setText("File");

        ExitMenuItem.setText("Exit");
        ExitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitMenuItemActionPerformed(evt);
            }
        });
        FileMenu.add(ExitMenuItem);

        MenuBar.add(FileMenu);

        //OptionsMenu.setText("Options");
        //MenuBar.add(OptionsMenu);

        HelpMenu.setText("Help");
        //HowToMenuItem.setText("How To");
        //HelpMenu.add(HowToMenuItem);
        //HelpMenu.add(About);

        MenuBar.add(HelpMenu);

        setJMenuBar(MenuBar);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ExitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_ExitMenuItemActionPerformed

    private void NoBoardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NoBoardActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_NoBoardActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem About;

    private javax.swing.JMenuItem ExitMenuItem;
    private javax.swing.JMenu FileMenu;
    private javax.swing.JMenu HelpMenu;
    private javax.swing.JMenuItem HowToMenuItem;
    private javax.swing.JPanel Image;
    private javax.swing.JPanel Info;
    private javax.swing.JMenuBar MenuBar;
    private javax.swing.JMenuItem NoBoard;
    private javax.swing.JMenu OptionsMenu;
    private javax.swing.JMenu SelectedBoard;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel statusLabel1;
    private javax.swing.JLabel statusLabel2;
    private javax.swing.JProgressBar progressBar;
    // End of variables declaration//GEN-END:variables
}
