package main;

/**
 * Main app launching GUI
 * v1.0 - 17.08.2022 initial release
 * @author Calin Bira &lt;calin.bira@upb.ro&gt;
 */

import utils.Logger;
import java.io.IOException;
import java.util.logging.Level;

public class Main {
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) throws IOException {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (Exception ex) {
            Logger.log(Level.SEVERE, ex.toString());
        }
        //</editor-fold>
        //</editor-fold>

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                //Logger.setLogLevel(Level.SEVERE);
                gui.GUI myGUI = new gui.GUI();
                myGUI.setVisible(true);
            }
        });
    }
}
