/**
 * Utility class
 *
 * @author Calin Bira &lt;calin.bira@upb.ro&gt;
 */

package utils;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

public class Utils {

    public static int ERROR_MESSAGE = JOptionPane.ERROR_MESSAGE;
    public static int INFORMATION_MESSAGE = JOptionPane.INFORMATION_MESSAGE;
    
    public static void messageBox(String Message, String titleBar, int priority)
    {
        JOptionPane.showMessageDialog(null, Message, titleBar, priority);
    }

    public static ArrayList<String> getFileContent(String filepath) {
        try {
            return (ArrayList<String>) Files.readAllLines((new File(filepath)).toPath());
        } catch (IOException ex) {
            return new ArrayList<>();
        }
    }
    
    public static void sleep_ms(int ms) {
        try {
            Thread.sleep(ms);
        } catch (InterruptedException ex) {
            Logger.getLogger(Utils.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
