var http = require('http');
var fs = require('fs');
var path = require('path');
var asyncMutex = require('async-mutex').Mutex;
const mutex = new asyncMutex();

var latest_json_obj;
var updates = 0;

http.createServer(function (request, response) {

    console.log('request starting...');
    console.log(contentType);

    var filePath = '.' + request.url;
    if (filePath == './')
        filePath = './html/index.html';

    var extname = path.extname(filePath);
    var contentType = 'text/html';
    switch (extname) {
        case '.js': contentType = 'text/javascript'; break;
        case '.css': contentType = 'text/css'; break;
        case '.json': contentType = 'application/json'; break;
        case '.png': contentType = 'image/png'; break;
        case '.jpg': contentType = 'image/jpg'; break;
        case '.wav': contentType = 'audio/wav'; break;
    }

    let data = []
    request.on('data', chunk => {
        data.push(chunk)
    })
    request.on('end', () => {
        if (data.length != 0)
            try {
                console.log(new Date().getTime());
                console.log(JSON.parse(data));
            }catch {
                console.log("Invalid JSON data: " + data);
            }

        response.writeHead(200, { 'Content-Type': contentType });
        response.end('post received');
    })

    console.log(filePath);

    //http://localhost:8888/?json={%22temperature%22%3A%2225%22%2C%22spo2%22%3A%22100%22}
    if (filePath.startsWith("./?json")) {
        try {
            const urlParams = new URLSearchParams(request.url);
            const json_text = urlParams.get('/?json');

            latest_json_obj = JSON.parse(json_text);
            currentDate = new Date();
            //latest_json_obj["ts"] = currentDate.getHours() + ":" + currentDate.getMinutes() + ":" + currentDate.getSeconds();

            for (var x in latest_json_obj) {
                console.log(x + " " + latest_json_obj[x]);
            }

        } catch (err) {
            console.error(err);
        }

        response.writeHead(200, { 'Content-Type': contentType });
        response.end();
    }
    else if (filePath.startsWith("./api/getdata")) {
        response.writeHead(200, { 'Content-Type': contentType });
        if (latest_json_obj != undefined)
            response.end(JSON.stringify(latest_json_obj), 'ascii');
        else
            response.end();
    }
    else
        fs.readFile(filePath, function(error, content) {
            if (error) {
                if(error.code == 'ENOENT'){
                    fs.readFile('./404.html', function(error, content) {
                        response.writeHead(200, { 'Content-Type': contentType });
                        response.end(content, 'utf-8');
                    });
                }
                else {
                    response.writeHead(500);
                    response.end('Sorry, check with the site admin for error: ' + error.code+' ..\n');
                    response.end();
                }
            }
            else {
                response.writeHead(200, { 'Content-Type': contentType });
                response.end(content, 'utf-8');
                response.end();
            }
        });

}).listen(8888);
console.log('Server running at http://localhost:8888/');