var http = require('http');
var fs = require('fs');
var path = require('path');
var asyncMutex = require('async-mutex').Mutex;
const mutex = new asyncMutex();

var latest_json_obj;

http.createServer(function (request, response) {
    console.log('request starting...');

    var filePath = '.' + request.url;
    if (filePath == './')
        filePath = './html/index.html';

    var extname = path.extname(filePath);
    var contentType = 'text/html';
    switch (extname) {
        case '.js':
            contentType = 'text/javascript';
            break;
        case '.css':
            contentType = 'text/css';
            break;
        case '.json':
            contentType = 'application/json';
            break;
        case '.png':
            contentType = 'image/png';
            break;
        case '.jpg':
            contentType = 'image/jpg';
            break;
        case '.wav':
            contentType = 'audio/wav';
            break;
    }

    console.log(filePath);
    //console.log(request.url);

    //http://localhost:8080/?json={%22temperature%22%3A%2225%22%2C%22spo2%22%3A%22100%22}
    if (filePath.startsWith("./?json")) {
        try {
            const urlParams = new URLSearchParams(request.url);
            const json_text = urlParams.get('/?json');

            latest_json_obj = JSON.parse(json_text);

            for (var x in latest_json_obj) {
                console.log(x + " " + latest_json_obj[x]);
            }

        } catch (err) {
            console.error(err);
        }

        response.writeHead(200, { 'Content-Type': contentType });
        response.end();
    }
    else if (filePath.startsWith("./api/getdata")) {

        response.writeHead(200, { 'Content-Type': contentType });
        if (latest_json_obj != undefined)
            response.end(JSON.stringify(latest_json_obj), 'ascii');
        else
            response.end();
    }
    else
        fs.readFile(filePath, function(error, content) {
        if (error) {
            if(error.code == 'ENOENT'){
                fs.readFile('./404.html', function(error, content) {
                    response.writeHead(200, { 'Content-Type': contentType });
                    response.end(content, 'utf-8');
                });
            }
            else {
                response.writeHead(500);
                response.end('Sorry, check with the site admin for error: ' + error.code+' ..\n');
                response.end();
            }
        }
        else {
            response.writeHead(200, { 'Content-Type': contentType });
            response.end(content, 'utf-8');
            response.end();
        }
    });

}).listen(8080);
console.log('Server running at http://localhost:8080/');